﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using ESRI.ArcGIS.esriSystem;

namespace JAMBWOW
{
    public static class PropertySetUtil
    {
        public static bool ContainsProperty(IPropertySet2 pPropertySet, string Name)
        {
            if (pPropertySet == null) return false;
            object names = null, values = null;
            pPropertySet.GetAllProperties(out names, out values);
            string[] nameArray = (string[])names;
            for (int i = 0; i < nameArray.GetLength(0); ++i)
            {
                if (nameArray[i] == Name) return true;
            }
            return false;
        }

        public static object GetPropertyValue<T>(IPropertySet2 pPropertySet, string Name)
        {
            if (pPropertySet == null) return false;
            if (ContainsProperty(pPropertySet, Name))
            {
                object myObject = pPropertySet.GetProperty(Name);
                if (myObject is T)
                    return myObject;
                else
                    return null;
            }
            else return null;                
        }

        //Determine if the propertyset contains another propertyset with a specific name.
        //If so, get it. If not, return a new propertyset.
        public static IPropertySet2 GetInnerPropSet(IPropertySet2 pPropertySet, string Name)
        {
            object oPropSet = GetPropertyValue<IPropertySet2>(pPropertySet, Name);
            if (oPropSet is IPropertySet2)
                return (IPropertySet2)oPropSet;
            else return new PropertySetClass();
        }
    }
}
