import arcpy, os, sys, traceback
from arcpy import env

#arcpy.AddMessage("Starting Script")

try:
    # Read parameter values
    command = arcpy.GetParameterAsText(0) #command name
    parameter = arcpy.GetParameterAsText(1) #input parameter
    #The third parameter is an output parameter

    mxd = arcpy.mapping.MapDocument("CURRENT")
    currentPageNum = mxd.dataDrivenPages.currentPageID
    pageCount = mxd.dataDrivenPages.pageCount

#    indexLayerName = mxd.dataDrivenPages.indexLayer.name
#    arcpy.AddMessage("Index layer Name: " + indexLayerName)
#    pageNameField = mxd.dataDrivenPages.pageNameField.name
#    arcpy.AddMessage("Page Name Field: " + pageNameField)

#    arcpy.AddMessage("command = " + command)
#    arcpy.AddMessage("parameter = " + parameter)
#    arcpy.AddMessage("currentPageNum = " + str(currentPageNum))
#    arcpy.AddMessage("pageCount = " + str(pageCount))

# Command that navigate to a page start here.
    if command == "FirstPage":
        mxd.dataDrivenPages.currentPageID = 1
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
    elif command == "PrevPage":
        pageNum = currentPageNum - 1
        if pageNum >= 1:
            mxd.dataDrivenPages.currentPageID = pageNum
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
    elif command == "NextPage":
        pageNum = currentPageNum + 1
        if pageNum <= pageCount:
            mxd.dataDrivenPages.currentPageID = pageNum
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
    elif command == "LastPage":
        mxd.dataDrivenPages.currentPageID = pageCount
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
    elif command == "GoToPage":
        newPageNum = int(parameter)
        if newPageNum > pageCount:
            newPageNum = pageCount
        if newPageNum < 1:
            newPageNum = 1
        mxd.dataDrivenPages.currentPageID = newPageNum
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
    elif command == "GoToPageFromName":
        pageID = mxd.dataDrivenPages.getPageIDFromName(parameter)
        mxd.dataDrivenPages.currentPageID = pageID
        arcpy.SetParameterAsText(2, str(mxd.dataDrivenPages.currentPageID))
# Other Commands (that do not navigate to a page) start here.
    elif command == "GetPageCount":
        arcpy.SetParameterAsText(2, str(pageCount))
    elif command == "GetCurrentPage":
        arcpy.SetParameterAsText(2, str(currentPageNum))
    elif command == "GetPageIDFromName":
        pageID = mxd.dataDrivenPages.getPageIDFromName(parameter)
        arcpy.SetParameterAsText(2, str(pageID))
    elif command == "Refresh":
        mxd.dataDrivenPages.refresh()
    elif command == "GetAttribute":
        myRow = mxd.dataDrivenPages.pageRow
        myValue = myRow.getValue(parameter)
        arcpy.SetParameterAsText(2, str(myValue))
except:
    arcpy.AddError("DDPUtil.py exited with the following error: " + traceback.format_exc())

#arcpy.AddMessage("Ending Script")
