﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace JAMBWOW
{
    public partial class ShuttleList : UserControl
    {
        List<object> m_FromListInit = new List<object>();
        List<object> m_ToListInit = new List<object>();

        public ShuttleList()
        {
            InitializeComponent();
        }

        public void InitializeLists(List<object> FromList, List<object> ToList)
        {
            try
            {

                //Store the intitial lists. (Used to reset the lists).
                m_FromListInit = FromList;
                m_ToListInit = ToList;
                //Initialize the "From" ListBox and the "To" ListBox.
                ResetLists();
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        #region Methods tied to user interface events

        private void cmdReset_Click(object sender, EventArgs e)
        {
            ResetLists();
        }

        private void cmdMove_Click(object sender, EventArgs e)
        {
            MoveSelected();
        }

        private void lstMoveFrom_DoubleClick(object sender, EventArgs e)
        {
            MoveSelected();
        }

        private void cmdMoveAll_Click(object sender, EventArgs e)
        {
            MoveAll();
        }

        private void cmdRemove_Click(object sender, EventArgs e)
        {
            RemoveSelected();
        }


        private void lstMoveTo_DoubleClick(object sender, EventArgs e)
        {
            RemoveSelected();
        }

        private void cmdRemoveAll_Click(object sender, EventArgs e)
        {
            RemoveAll();
        }

        #endregion

        #region Non-UI methods

        private void ResetLists()
        {
            try
            {
                //Reset the "From" ListBox and the "To" ListBox.
                lstMoveFrom.Items.Clear();
                foreach (object oFromItem in m_FromListInit) lstMoveFrom.Items.Add(oFromItem);
                lstMoveTo.Items.Clear();
                foreach (object oToItem in m_ToListInit) lstMoveTo.Items.Add(oToItem);
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        private void MoveSelected()
        {
            try
            {
                List<object> MyObjects = new List<object>();
                foreach (object MyObject in lstMoveFrom.SelectedItems) MyObjects.Add(MyObject);
                foreach (object MyObject in MyObjects)
                {
                    lstMoveTo.Items.Add(MyObject);
                    lstMoveFrom.Items.Remove(MyObject);
                }
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        private void MoveAll()
        {
            try
            {
                List<object> MyObjects = new List<object>();
                foreach (object MyObject in lstMoveFrom.Items) MyObjects.Add(MyObject);
                foreach (object MyObject in MyObjects)
                {
                    lstMoveTo.Items.Add(MyObject);
                    lstMoveFrom.Items.Remove(MyObject);
                }
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        private void RemoveSelected()
        {
            try
            {
                List<object> MyObjects = new List<object>();
                foreach (object MyObject in lstMoveTo.SelectedItems) MyObjects.Add(MyObject);
                foreach (object MyObject in MyObjects)
                {
                    lstMoveFrom.Items.Add(MyObject);
                    lstMoveTo.Items.Remove(MyObject);
                }
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        private void RemoveAll()
        {
            try
            {
                List<object> MyObjects = new List<object>();
                foreach (object MyObject in lstMoveTo.Items) MyObjects.Add(MyObject);
                foreach (object MyObject in MyObjects)
                {
                    lstMoveFrom.Items.Add(MyObject);
                    lstMoveTo.Items.Remove(MyObject);
                }
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        #endregion



    }
}
