﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace JAMBWOW
{
    public class TempFile
    {
        private string m_tempName;

        //Constructor
        public TempFile(string BaseName, string Extension)
        {
            Random randObj = new Random();
            string strRND = ((int)(randObj.NextDouble() * 2147483647)).ToString();
            m_tempName = BaseName + strRND + "." + Extension;
        }

        //Destructor
        ~TempFile()
        {
            DeleteTempFile();
        }

        //-----------------
        //Public functions
        //-----------------

        //Get the full path name of the temporary file.
        //Precondition: The TEMP environment variable is set.
        //Postcondition: The path to the temporary file is returned.
        //@return Full path temporary file
        public string TempFileName()
        {
            string strEnv = Environment.GetEnvironmentVariable("TEMP");
            return strEnv + "\\" + m_tempName;
        }

        //-----------------
        //Private functions
        //-----------------

        //If the Temporary file exists, delete it.
        //Precondition: The user has delete file permission on the file, if it exists.
        //Postcondition: The file does not exist in the temporary folder.
        private void DeleteTempFile()
        {
            try
            {
                if (System.IO.File.Exists(TempFileName()))
                    System.IO.File.Delete(TempFileName());
            }
            catch
            {
                MessageBox.Show("An error occured while trying to delete a temporary file.", "Survey Plot");
            }
        }
    }
}
