﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using ESRI.ArcGIS.Geoprocessing;
using ESRI.ArcGIS.GeoprocessingUI;
using ESRI.ArcGIS.Geodatabase;

namespace JAMBWOW
{
    public class cmdESRIGridMapGen : ESRI.ArcGIS.Desktop.AddIns.Button
    {
        public cmdESRIGridMapGen()
        {
        }

        protected override void OnClick()
        {
            try
            {
                string sArcGIS_Install_Path = GenUtil.GetArcGISInstallPath();

                //Set a reference to the IGPCommandHelper2 interface.
                IGPToolCommandHelper2 pToolHelper = new GPToolCommandHelperClass() as IGPToolCommandHelper2;

                //Set the tool you want to invoke.
                string toolboxName = sArcGIS_Install_Path + @"ArcToolbox\Toolboxes\Cartography Tools.tbx";
                pToolHelper.SetToolByName(toolboxName, "GridIndexFeatures");

                //Create the messages object and a bool to pass to the InvokeModal method.
                IGPMessages msgs;
                msgs = new GPMessagesClass();
                bool pok = true;

                //Invoke the tool. 
                pToolHelper.InvokeModal(0, null, out pok, out msgs);
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        protected override void OnUpdate()
        {
        }
    }
}
