﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;

using ESRI.ArcGIS.Carto;
using ESRI.ArcGIS.ArcMapUI;

namespace JAMBWOW
{
    public class cmdLayerConvertToAnno : ESRI.ArcGIS.Desktop.AddIns.Button
    {
        public cmdLayerConvertToAnno()
        {
        }

        protected override void OnClick()
        {
            try
            {
                //Get the item in the table of contents that was right-clicked.
                IMxDocument pMxDoc = GenUtil.GetMxDocument();
                object MyLayer = pMxDoc.ContextItem;                
                if (MyLayer is FeatureLayer && !(MyLayer is FDOGraphicsLayer))
                {
                    ILayer pLayer = (ILayer)MyLayer;
                    string sLayerName = pLayer.Name;
                    if (pLayer.Valid)
                    {
                        List<ILayer> pLayers = new List<ILayer>();
                        pLayers.Add((ILayer)MyLayer);
                        bool bLayersProcessed = AnnotationUtil.ConvertLabelsToPageSpecificAnno(pLayers);
                        if (bLayersProcessed == false)
                            MessageBox.Show("This layer already has associated annotation.", "JambWow");
                    }
                    else MessageBox.Show("The '" + sLayerName + "' layer is not valid. Repair its data source and try again. I cannot convert its labels to annotation.", "JambWow");
                }
                else MessageBox.Show("This is not a feature layer. I cannot convert its labels to annotation.", "JambWow");
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        protected override void OnUpdate()
        {
        }
    }
}
