﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;

using ESRI.ArcGIS.Carto;
using ESRI.ArcGIS.ArcMapUI;

namespace JAMBWOW
{
    public class cmdLayerDeleteAnnotationThisPageOnly : ESRI.ArcGIS.Desktop.AddIns.Button
    {
        public cmdLayerDeleteAnnotationThisPageOnly()
        {
        }

        protected override void OnClick()
        {
            try
            {
                //Get the item in the table of contents that was right-clicked.
                IMxDocument pMxDoc = GenUtil.GetMxDocument();
                object MyLayer = pMxDoc.ContextItem;
                if (MyLayer is FeatureLayer && !(MyLayer is FDOGraphicsLayer))
                {
                    List<ILayer> pLayers = new List<ILayer>();
                    pLayers.Add((ILayer)MyLayer);
                    bool bLayersProcessed = AnnotationUtil.DeleteAnnotatioFeaturesThisPageOnly(pLayers);
                    if (bLayersProcessed == false)
                        MessageBox.Show("This layer does not have associated annotation for this page.", "JambWow");
                }
                else MessageBox.Show("This is not a feature layer. I cannot delete its associated annotation layer.", "JambWow");
            }
            catch (Exception pException)
            {
                GenUtil.ShowError(pException);
            }
        }

        protected override void OnUpdate()
        {
        }
    }


}
